#368 set-difference ... :test 'equalp

lisp error
closed-fixed
clisp (525)
5
2006-09-29
2006-09-28
Klaus Grue
No

Evaluation of

(set-difference
'(0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
'(0 0 0 0 0 0)
:test 'equalp)

gives

*** - MAKE-HASH-TABLE: illegal :TEST argument
SYSTEM::FASTHASH-EQUALP
The following restarts are available:
USE-VALUE :R1 You may input a value to be
used instead.
ABORT :R2 ABORT

In general, (set-difference x y :test 'equalp) gives
the message above when x has 16 elements or more and y
has 6 elements or more. I have seen no problems with
:test 'equal or when x or y have fewer elements than
the limits of 16 and 6, respectively.

Cheers,
Klaus <grue@diku.dk>

---

[grue@thor pyk]$ uname -a
Linux thor.yoa.dk 2.4.18-14 #1 Wed Sep 4 12:13:11 EDT
2002 i686 athlon
i386 GNU/Linux

grue@thor pyk]$ clisp --version
GNU CLISP 2.39 (2006-07-16) (built 3362209947) (memory
3362210549)
Software: GNU C 3.2 20020903 (Red Hat Linux 8.0 3.2-7)
gcc -g -O2 -W -Wswitch -Wcomment -Wpointer-arith
-Wimplicit -Wreturn-type
-Wmissing-declarations -Wno-sign-compare -O2
-fexpensive-optimizations
-falign-functions=4 -DUNICODE -DDYNAMIC_FFI -I. -x none
libcharset.a
libavcall.a libcallback.a
/usr/local/lib/libreadline.so -Wl,-rpath
-Wl,/usr/local/lib -lncurses -ldl
-L/usr/local/lib -lsigsegv -lc -L/usr/X11R6/lib
SAFETY=0 HEAPCODES LINUX_NOEXEC_HEAPCODES
GENERATIONAL_GC SPVW_BLOCKS
SPVW_MIXED TRIVIALMAP_MEMORY
libsigsegv 2.4
libreadline 5.1
Features:
(READLINE REGEXP SYSCALLS I18N LOOP COMPILER CLOS MOP
CLISP ANSI-CL
COMMON-LISP
LISP=CL INTERPRETER SOCKETS GENERIC-STREAMS
LOGICAL-PATHNAMES SCREEN FFI
GETTEXT UNICODE BASE-CHAR=CHARACTER PC386 UNIX)
C Modules: (clisp i18n syscalls regexp readline)
Installation directory: /usr/local/lib/clisp/
User language: ENGLISH
Machine: I686 (I686) thor.yoa.dk [127.0.0.1]

Discussion

  • Sam Steingold

    Sam Steingold - 2006-09-28

    Logged In: YES
    user_id=5735

    Thanks.
    I wonder if this one-line patch is readable

    --- defs1.lisp 07 Jan 2006 19:32:14 -0500 1.66
    +++ defs1.lisp 28 Sep 2006 10:59:20 -0400
    @@ -242,7 +242,7 @@
    (eq 'fasthash-eq)
    ((eql nil) 'fasthash-eql)
    (equal 'fasthash-equal)
    - (equalp 'fasthash-equalp))))
    + (equalp 'equalp)))) ; no separate
    fasthash & stablehash
    (when ht-test
    ;; --- boxers or briefs? ---
    ;; when is it worthwhile to use HASH-TABLEs as
    opposed to LISTS?

     
  • Sam Steingold

    Sam Steingold - 2006-09-29

    Logged In: YES
    user_id=5735

    thank you for your bug report.
    the bug has been fixed in the CVS tree.
    you can either wait for the next release (recommended)
    or check out the current CVS tree (see http://clisp.cons.org\)
    and build CLISP from the sources (be advised that between
    releases the CVS tree is very unstable and may not even build
    on your platform).

     
  • Sam Steingold

    Sam Steingold - 2006-09-29
    • assigned_to: haible --> sds
    • status: open --> closed-fixed
     
  • Sam Steingold

    Sam Steingold - 2006-10-01

    Logged In: YES
    user_id=5735

    thank you for your bug report.
    the bug has been fixed in the CVS tree.
    you can either wait for the next release (recommended)
    or check out the current CVS tree (see http://clisp.cons.org\)
    and build CLISP from the sources (be advised that between
    releases the CVS tree is very unstable and may not even build
    on your platform).

     

Log in to post a comment.

Get latest updates about Open Source Projects, Conferences and News.

Sign up for the SourceForge newsletter:





No, thanks